/* GPLv2 applies
 * SVN revision: $Revision: 513 $
 * (C) 2006-2013 by folkert@vanheusden.com
 */
typedef enum { DCC_RECEIVE_FILE, DCC_SEND_FILE, DCC_CHAT } dcc_type_t;

typedef struct
{
	dcc_type_t mode;
	conn_state_t state;
	int fd_conn;
	int fd_file;
	int server_nr, channel_nr;
	time_t las_update;
} DCC_t;

extern DCC_t *dcc_list;
extern int n_dcc;
extern char *dcc_path;

void init_dcc(void);
void init_recv_dcc(const char *filename, unsigned long int ip, int port, int server_index, int channel_index);
int init_send_dcc(const char *filename, int server_index, const char *nick);
void set_dcc_state(int index, conn_state_t state);
conn_state_t get_dcc_state(int index);
int dcc_send(DCC_t *pnt);
int dcc_receive(DCC_t *pnt);
void free_dcc(void);
int register_dcc_events(fd_set *rfds, fd_set *wfds);
void process_dcc_events(fd_set *rfds, fd_set *wfds);
